#!/usr/bin/python

import datetime
import os


def get_size(start_path='.'):
    total_size = 0
    for dirpath, dirnames, filenames in os.walk(start_path):
        for f in filenames:
            fp = os.path.join(dirpath, f)
            total_size += os.path.getsize(fp)
    return total_size


number_of_folders = len(next(os.walk('./images'))[1])
MAX_PER_WEEK = 2
TOTAL_NUMBER_OF_WEEKS = 20
max_allowed_value = int(number_of_folders*2)
total_max_allowed = MAX_PER_WEEK*TOTAL_NUMBER_OF_WEEKS

file1 = open("size_counter.md", "w")
header = "# Automatic Repo Size Checker\n"
info = "\n This page was generated using a [python script](http://\
    `fabacademy.org/2019/labs/waag/students/jacopo-dimatteo/assignments/\
    week02/#automatic-repo-size-checker), it keeps track of the size of my\
     repo.\n"

currentDT = datetime.datetime.now()
last_time_run = str(currentDT.strftime("%a, %b %d, %Y - %H:%M:%S"))
last_time_run = '\nDate of last run : **{}**\n'.format(last_time_run)

stats = "\n## Stats\n"
weeks_active = "\n The number of weeks active are : {}\n".format(
    number_of_folders)
limit_per_week = "\n 'Ideal' expansion per week : {} Mb\n".format(MAX_PER_WEEK)
allowed_value = "\n Max size for number of active weeks: 2 Mb per week x\
{} weeks = {} Mb\n".format(number_of_folders, max_allowed_value)
tot_value = "\n Overall max value for all weeks: {} Mb\n".format(
    total_max_allowed)

usage = "\n## Usage\n"
jacopo = round(get_size("../../jacopo-dimatteo") * 10**-6, 3)
docs = round(get_size("../docs") * 10**-6, 3)
images = round(get_size("./images") * 10**-6, 3)
git = round(get_size("../.git") * 10**-6, 3)
git_to_doc_diff = round(git - docs, 3)

total_space_used = "\nSize of ^^repo^^ : {}Mb\n".format(jacopo)
space_used_by_docs = "\nSize of `docs` folder : {}Mb\n".format(docs)
space_used_by_img = "\nSize of `images` folder : {}Mb\n".format(images)
space_used_by_git = "\nSize of `.git` folder : {}Mb\n".format(git)
difference = "\nDifference between effective size & active size (`.git` -\
    `docs`) : {}Mb\n".format(
    git_to_doc_diff)

warnings = "\n## Warnings\n"
if jacopo > total_max_allowed:
    tot_stat = '\n!!!error "Your ^^repo^^ is over the total max value!"\n'
elif jacopo > max_allowed_value:
    tot_stat = '\n!!!warning "Your ^^repo^^ is over the soft limit"\n'
else:
    tot_stat = '\n!!!check "Your ^^repo^^ is in check"\n'

if docs > max_allowed_value:
    doc_stat = '\n!!!warning "Your `docs` folder is over the limit"\n'
else:
    doc_stat = '\n!!!check "Your `docs` folder is in check"\n'

if images > max_allowed_value:
    img_stat = '\n!!!warning "Your `images` folder is over the limit"\n'
else:
    img_stat = '\n!!!check "Your `images` folder is in check"\n'

lines = [header, info, last_time_run, stats, weeks_active, limit_per_week,
         allowed_value, tot_value, usage, total_space_used, space_used_by_docs,
         space_used_by_img, space_used_by_git, difference, warnings, tot_stat,
         doc_stat, img_stat]
file1.writelines(lines)
file1.close()  # to change file access modes

# -- Compress file & add to file direcotry for staging --
python_filename = "./files/week02/count.py.zip"
mod_time = os.stat(python_filename).st_mtime

command_1 = 'zip ./count.py.zip ./count.py'
command_2 = 'rm ./files/week02/count.py.zip'
command_3 = 'mv ./count.py.zip ./files/week02'
commands = [command_1, command_2, command_3]
for command in commands:
    os.system(command)

if mod_time == os.stat(python_filename).st_mtime:
    print("ZIP HASN'T BEEN MODIFIED!")
